'=========================================
' Modbus test/load software
'
'=========================================
	Dim Com$(16)					' file name for open function
	Dim br$(16)					' broadcast address on local network
	Dim i	
	Dim V	
	Dim adr,hw,br
	Dim s$(256)
	Dim m$(129)
	Dim p$(257)
	Dim c$(2)
	Dim crc
	Dim FLen
	Dim st$(256)

	SYSLOG "MBT (TCP) Application for BARIX Barionet v15"
	hw=iostate(60000)
	SYSLOG "HW = " + SPRINTF$("%u",hw)
	If hw=26 then
	  br=1
	 ELSE
	  br=4
	ENDIF

	Open "STP:0" as 0
	read 0,st$
	
	COM$ = "COM::2"						' open rs485
	Open "COM::2" as 4
	Open "TCP:0.0.0.0:12345" as 1				' open control port, we'll use TCP now, port 12345
	
11111
	If connected(1)Then GoTo 1				' wait for a connection here
	GoTo 11111
	
1	t1=_TMR_(0)
	Write 1,"\r\nModbus and X8/R6 Test Application\r\nPlease select: 1 for factory, 2 for service mode, 3 for loader ",0
2
	If _TMR_(0)-t1>5000 Then			' input timeout
	  i=midget(st$,250,1)
	Else  
	  read 1,c$,1
	  If lastlen(1)<1 Then GoTo 2
	  i=Val(c$)
	endif
	If i<>midget(st$,250,1) Then			' store new default selection !
	  midset st$,250,1,i
	  Write 0,st$,256
	  Close 0
	  Open "STP:0" as 0
	  read 0,st$
	endif
	If i=2 Then GoTo 10
	If i=1 Then GoTo 50
	If i=3 Then GoTo 70
	If i=9 Then GoTo 12				' don't change serial ...
	GoTo 1
	
10	If or(midget(st$,34,1)<>48,midget(st$,33,1)<>br) Then
	  Write 1,"\n\rwrong serial setup - correcting & rebooting ..\n\r",0
	  midset st$,33,1,br
	  midset st$,34,1,48
	  midset st$,250,1,2
	  Write 0,st$,256
	  Close 0
	  Close 1
	  Lock 1 
11        GoTo 11	
	endif

12
	Write 1,"\r\nWadr,reg,val | Radr,reg,num or | sSadr,coil,val | bBadr | Is1,s2 | Cs1,s2 | Fs1,s2 | X ?\r\n",0
	GoSub 9000
	c$=mid$(s$,1,1)
	If c$="X" Then GoTo 1
	If c$="W" Then GoSub 100
	If c$="R" Then 
	  GoSub 200
	  If rdlen>0 Then
	    s$="READ: "
	    For i=1 to midget(t$,3,1)
	      j=(256*midget(t$,3+i,1)) + midget(t$,3+i+1,1)
	      i=i+1
	      s$=s$+sprintf$("%04x ",j)
	    Next i
	    syslog s$
	    Write 1,s$+"\n\r",0
	  endif
	endif
	If c$="B" Then GoTo 300
	If c$="S" Then GoSub 400
	If c$="s" Then GoSub 401		' S without acknowledge
	If c$="I" Then GoSub 500		' init relay unit
	If c$="C" Then GoTo 600		' config set to one
	If c$="F" Then GoTo 600		' firmware reload, same as config but other command
	If c$="b" Then GoSub 700		' broadcast bit test
	GoTo 12

50 	' factory mode
	If or(midget(st$,34,1)<>48,midget(st$,33,1)<>br) Then
	  Write 1,"\n\rwrong serial setup - correcting & rebooting ..\n\r",0
	  midset st$,33,1,br
	  midset st$,34,1,48
	  midset st$,250,1,2
	  Write 0,st$,256
	  Close 0
	  Lock 1 
51        GoTo 51
	endif



	' ask for software version and serial number, then start loading and testing automatically
	Write 1,"\r\nTo start, please enter serialhi,seriallo ?",0
	GoSub 9000					' get line
	s1=Val(mid$(s$,1,Len(s$)-1))
	i=InStr(1,s$,",")
	If i=0 Then GoTo 50
	s2=Val(mid$(s$,i+1,Len(s$)-i))
	' now try to detect unit by constantly reading and waiting for result
60	delay 100
61	read 1,c$
	If lastlen(1)>0 Then
	  If or(c$="X",c$="x") Then GoTo 1 Else GoTo 61
	endif
	adr=255 r=256 v=4				' read one register from 256
	GoSub 210
	If and(rdlen>0,midget(t$,2,1)=3) Then
	  typ=and(15,midget(t$,5,1))
	  fnew=and(midget(t$,9,1)=255,midget(t$,11,1)=255)
	  adr=255
	  ftest=0
	  GoSub 10000
	  If and(ftest,fnew) Then	' found new unit and tested successfully !
	    Write 1,"\r\n----> Initialising device with serial number "+str$(s1)+"-"+str$(s2)+sprintf$(" (%04u) !",s1*256+s2),0
	    If typ=2 Then byt1=&HFF00 Else byt1=0				' pullup enable on X8, otherwise 0 for R6/IO12
	    GoSub 510							' program it !
	    If and(rdlen>0,midget(t$,2,1)=16) Then Write 1," FINISHED\n\r",0 Else Write "ERROR"
	  endif
	  delay 2000
	endif
	GoTo 60

70	If or(midget(st$,34,1)<>128,midget(st$,33,1)<>br) Then
	  Write 1,"\n\rwrong serial setup - correcting & rebooting ..\n\r",0
	  midset st$,33,1,br
	  midset st$,34,1,128
	  Write 0,st$,256
	  Close 0
	  Lock 1 
71        GoTo 71	
	endif
	Write 1,"\r\nloader started, please reset unit. Press F for erase command, S to send firmware\r\n",0
72						' wait for status or firmware request here
	read 1,c$,1
	If lastlen(1)>0 Then
	  If c$="X" Then GoTo 1			; back to menu
	  If or(c$="F",c$="f") Then 
271	    read 4,s$				' clean out memory
	    Write 4,"U00??????"+chr$(13),0
	    GoTo 72
	  endif
	  If or(c$="S",c$="s") Then GoTo 272
	endif
	read 4,c$,1
	If lastlen(4)<=0 Then GoTo 72
	If c$="U" Then
	  Write 1,"received status request\r\n",0
	  GoTo 72
	endif
	If c$=chr$(34) Then
	  Write 1,"firmware load complete\r\n",0
	  GoTo 72
	endif
	If c$<>"!" Then
'	  Write 1,sprintf$("ignored incoming byte %u\r\n",Asc(c$)),0
	  GoTo 72
	endif
272	
	Write 1,"sending firmware\r\n",0
	f$= "F_R:mb.hex"
	Open f$ as 2
	delay 100
73
	read 2,s$,0
	If lastlen(2)<1 Then GoTo 74
	Write 4,s$,0
	delay 100
	GoTo 73
74	Write 1,"end programming\r\n",0
	Close 2
	GoTo 72

100					' modbus write
	adr=Val(mid$(s$,2,Len(s$)-1))
	i=InStr(1,s$,",")
	If i=0 Then GoTo 900
	r=Val(mid$(s$,i+1,Len(s$)-i))
	i=InStr(i+1,s$,",")
	If i=0 Then GoTo 900
	v=Val(mid$(s$,i+1,Len(s$)-i))
110
	midset m$,1,1,adr			' set address
	midset m$,2,1,6				' Set register command
	midset m$,3,1,shr(r,8)			' hi address
	midset m$,4,1,and(r,255)		' low address
	midset m$,5,1,shr(v,8)			' hi value
	midset m$,6,1,and(v,255)		' lo value
	midset m$,7,1,0				' crc value
	midset m$,8,1,0				' crc value
	mlen=8
	GoSub 1000				' make modbus crc
	GoSub 3000				' dump block
	GoSub 2500				' read out stuff from interface, if stuck
	Write 4,m$,mlen				' send out the block
	GoTo 2000				' wait for answer (will return)

200					' modbus read
	adr=Val(mid$(s$,2,Len(s$)-1))
	i=InStr(1,s$,",")
	If i=0 Then GoTo 900
	r=Val(mid$(s$,i+1,Len(s$)-i))
	i=InStr(i+1,s$,",")
	If i=0 Then GoTo 900
	v=Val(mid$(s$,i+1,Len(s$)-i))
	If v>120 Then Write 1,"Too many registers to read !\n\r",0 Return
210
	midset m$,1,1,adr			' set address
	midset m$,2,1,3				' read registers command
	midset m$,3,1,shr(r,8)			' hi address
	midset m$,4,1,and(r,255)		' low address
	midset m$,5,1,0				' hi number
	midset m$,6,1,v				' lo number
	midset m$,7,1,0				' crc value
	midset m$,8,1,0				' crc value
	mlen=8
	GoSub 1000				' make modbus crc
	GoSub 3000				' dump block
	GoSub 2500				' read out stuff from interface, if stuck
	Write 4,m$,mlen				' send out the block
	GoSub 2000				' wait for answer
	Return
	
300					' test broadcast mode
	For l=1 to 40
	  adr=Val(mid$(s$,2,Len(s$)-1))

	  midset m$,1,1,0			' BROADCAST
	  midset m$,2,1,68		' Set multibyte
	  midset m$,3,1,shr(adr,8)			' hi address
	  midset m$,4,1,and(adr,255)			' low address
	  midset m$,5,1,0				' num bytes hi
	  midset m$,6,1,4				' num outputs lo
	  midset m$,7,1,4				' num bytes (redundant)
	  midset m$,8,1,&HAA
	  midset m$,9,1,&H55
	  midset m$,10,1,&H00
	  midset m$,11,1,&H44
	  midset m$,12,1,0				' crc value
	  midset m$,13,1,0				' crc value
	  mlen=13
	  GoSub 1000				' make modbus crc
	  GoSub 3000				' dump block
	  Write 4,m$,mlen				' send out the block

	  midset m$,1,1,0			' BROADCAST
	  midset m$,2,1,68		' Set multibyte
	  midset m$,3,1,shr(adr,8)			' hi address
	  midset m$,4,1,and(adr,255)			' low address
	  midset m$,5,1,0				' num bytes hi
	  midset m$,6,1,4				' num outputs lo
	  midset m$,7,1,4				' num bytes (redundant)
	  midset m$,8,1,&H55
	  midset m$,9,1,&HAA
	  midset m$,10,1,&H22
	  midset m$,11,1,&H00
	  midset m$,12,1,0				' crc value
	  midset m$,13,1,0				' crc value
	  mlen=13
	  GoSub 1000				' make modbus crc
	  GoSub 3000				' dump block
	  read 4,t$				' read out stuff from interface, if stuck
	  Write 4,m$,mlen				' send out the block
	Next l
	GoTo 10

400					' modbus set coil
	midset m$,2,1,5				' Set coil command
	GoTo 402
401	midset m$,2,1,70
402
	adr=Val(mid$(s$,2,Len(s$)-1))
	i=InStr(1,s$,",")
	If i=0 Then GoTo 900
	r=Val(mid$(s$,i+1,Len(s$)-i))
	i=InStr(i+1,s$,",")
	If i=0 Then GoTo 900
	v=Val(mid$(s$,i+1,Len(s$)-i))
	If v<>0 Then v=255
410
	midset m$,1,1,adr			' set address
	midset m$,3,1,shr(r,8)			' hi address
	midset m$,4,1,and(r,255)		' low address
	midset m$,5,1,v				' hi value
	midset m$,6,1,0				' lo value
	midset m$,7,1,0				' crc value
	midset m$,8,1,0				' crc value
	mlen=8
	GoSub 1000				' make modbus crc
	GoSub 3000				' dump block
	GoSub 2500				' read out stuff from interface, if stuck
	Write 4,m$,mlen				' send out the block
	rdlen=0
	If midget(m$,2,1)=5 Then GoSub 2000	' wait for answer for command 5
	Return

500					' modbus init unit
	If Len(s$)>1 Then
	  s1=Val(mid$(s$,2,Len(s$)-1))
	  i=InStr(1,s$,",")
	  If i=0 Then GoTo 900
	  s2=Val(mid$(s$,i+1,Len(s$)-i))
	endif
	If or(s1=0,s2=0) Then Write 1," no valid serial number ",0 Return
	byt1=&H0000				' init value For first byte in setup (pullup enable On X8)
	Write 1,"Init with serial number "+str$(s1)+"-"+str$(s2)+"\r\n",0
510
	midset m$,1,1,255			' set address to 255 (new unit or default jumper)
	midset m$,2,1,16			' Set "write multiple" command
	midset m$,3,1,1				' hi address
	midset m$,4,1,2			 	' low address
	midset m$,5,1,0				' hi number of regs
	midset m$,6,1,18			' lo number of regs
	midset m$,7,1,36			' number of bytes following
	For i=8 to 34 midset m$,i,2,&HFF00 i=i+1 Next i	' set all default to 00 FF
	midset m$,9,1,s1			' serial number
	midset m$,11,1,s2			' serial number2
	midset m$,36,2,0			' default startup value
	midset m$,38,2,0			' I/O parameters
	midset m$,40,2,&HFF00			' address stays at FF
	midset m$,42,2,0			' reserved, preset to 0
	midset m$,44,2,0			' crc (16bit)
	mlen=45
	GoSub 1000				' make modbus crc
	GoSub 3000				' dump block
	GoSub 2500				' read out stuff from interface, if stuck
	Write 4,m$,mlen				' send out the block
	delay 300				' give time to execute and answer!
	GoSub 2000				' wait for answer
	s2=s2+1
	Return

600					' config test set
	s1=Val(mid$(s$,2,Len(s$)-1))
	i=InStr(1,s$,",")
	If i=0 Then GoTo 900
	s2=Val(mid$(s$,i+1,Len(s$)-i))
	midset m$,1,1,0				' send broadcast
	midset m$,2,1,69			' Send special "set config"
	If mid$(s$,1,1)="F" Then midset m$,2,1,71	' this is firmware reload command
	midset m$,3,1,s1			' hi address
	midset m$,4,1,s2		 	' low address
	midset m$,5,1,s1			' hi number of regs
	midset m$,6,1,s2			' lo number of regs
	midset m$,7,1,1				' test - set relay 1 at startup
	midset m$,8,1,0				' serial "standard"
	midset m$,9,1,1				' set to address 1
	midset m$,10,1,0			' reserved
	mlen=12
	GoSub 1000				' make modbus crc
	GoSub 3000				' dump block
	GoSub 2500				' read out stuff from interface, if stuck
	Write 4,m$,mlen				' send out the block
	GoSub 2000				' wait for answer
	s2=s2+1
	GoTo 10

700
	adr=Val(mid$(s$,2,Len(s$)-1))		' get address
710
	midset m$,1,1,adr
	midset m$,2,1,70		' Set multibyte
        midset m$,3,1,0			' hi address
	midset m$,6,1,0			' value low
	mlen=8
	
	For i=0 to 7
	  midset m$,4,1,i		' address
	  midset m$,5,1,255		' to on
	  GoSub 1000
	  midcpy p$,1+16*i,8,m$
	  GoSub 3000
	  midset m$,4,1,and(7,i-1)	' address-1
	  midset m$,5,1,0		' to off
	  GoSub 1000
	  midcpy p$,9+16*i,8,m$
	  GoSub 3000
	Next i
	If adr<>255 Then midset m$,1,1,adr+1 	' if 255, only own unit tested (2x)
	For i=0 to 7
	  midset m$,4,1,i		' address
	  midset m$,5,1,255		' to on
	  GoSub 1000
	  midcpy p$,129+16*i,8,m$
	  GoSub 3000
	  midset m$,4,1,and(7,i-1)	' address-1
	  midset m$,5,1,0		' to off
	  GoSub 1000
	  midcpy p$,137+16*i,8,m$
	  GoSub 3000
	Next i

	read 1,s$,100
720
	Write 4,p$,256				' send out the block
	read 1,s$,1
	If lastlen(1)<=0 Then GoTo 720
	Return

	
900	Write 1,"\r\nArgument Error",0
	GoTo 10	

1000						' calculate modbus CRC
	crc=&HFFFF
	For i1000=1 to mlen-2
	  crc=xor(crc,midget(m$,i1000,1))
	  If and(crc,1) Then crc=xor(crc,&H14002)
	  If and(crc,2) Then crc=xor(crc,&H28004)
	  If and(crc,4) Then crc=xor(crc,&H50008)
	  If and(crc,8) Then crc=xor(crc,&HA0010)
	  If and(crc,16) Then crc=xor(crc,&H140020)
	  If and(crc,32) Then crc=xor(crc,&H280040)
	  If and(crc,64) Then crc=xor(crc,&H500080)
	  If and(crc,128) Then crc=xor(crc,&HA00100)
	  crc=shr(crc,8)
	Next i1000	
	midset m$,mlen-1,2,crc			' store crc lowbyte first
	Return


' read back answer from modbus in t$
2000
	delay 100
	rdlen=0
	j=_TMR_(0)
2020
	read 4,t$,10				' try to read
	If AND(_TMR_(0)-j<30,lastlen(4)<=0) Then GoTo 2020

	If lastlen(4)>0 Then
	  rdlen=lastlen(4)
	  p$=sprintf$("read: %d bytes: ",rdlen)
	  For i=1 to rdlen 
	    p$=p$+sprintf$(" %02x",midget(t$,i,1)) 
	    If Len(p$)>128 Then i=rdlen+1
	  Next i
	  syslog p$
	  If midget(t$,2,1)>128 Then Write 1,"Exception - address or data error\n\r",0 rdlen=0
	Else
	  syslog "no answer from modbus device"
	  Write 1,"?",0 rdlen=0
	endif
	Return
	
2500	' flush serial interface
	read 4,t$
	If lastlen(4)>0 Then GoTo 2500
	Return
	
3000
	s3$="blk: "
	For i3000=1 to mlen
	  s3$=s3$+sprintf$("%02X ",midget(m$,i3000,1))
	Next i3000
	syslog s3$
	Return
	

9000	
	' get line - with echo (up to CR)
	s$=""
	i9000=1

9020	read 4,c$,1
	If lastlen(4)>0 Then
	  syslog sprintf$("first read: %u",lastlen(4))
	  j9000=Asc(c$)
          delay(5)
	  read 4,c$,1
	  If and(lastlen(4)>0,j9000=Asc(c$)) Then
	    If Asc(c$)>0 Then Write 1,sprintf$("\r*** Data ready indication from %u ***\r\n",Asc(c$)),0
	  Else 
	    syslog "lastlen "+str$(lastlen(4))
	    Write 1,sprintf$("noise %u<>",j9000)+sprintf$("%u",Asc(c$)),0
	  endif
	endif
	read 1,c$,1
	If lastlen(1)<>1 Then GoTo 9020			' wait For character
	If c$=chr$(13) Then 				' Line complete
	  Write 1,"\r\n",0
	  Return
	endif
	If c$=chr$(8) Then
	  If i9000>1 Then
	    Write 1,chr$(8)+" "+chr$(8),0
	    i9000=i9000-1
	    If i9000=1 Then s$="" Else s$=mid$(s$,1,Len(s$)-1)
	    GoTo 9020
	  Else
	    Write 1,chr$(7),0
	    GoTo 9020
	  endif
	endif
	If Asc(c$)<32 Then GoTo 9020
	Write 1,c$,1
	s$=s$+c$					' Add char to String
	i9000=i9000+1
	GoTo 9020				


10000					' unit test - depending On device Type !
	ftest=0
	Write 1,"\n\rTest device ",0
	If fnew Then 
	  Write 1,"NEW, type "+str$(typ),0
	Else
	  Write 1,sprintf$("sernr %u,",midget(t$,9,1))+sprintf$("%u (",midget(t$,11,1))+sprintf$("%04u), type ",midget(t$,9,1)*256+midget(t$,11,1))+str$(typ),0
	endif
	On typ GoTo 10100,10200,10300,10300
	Write "unknown type !"
	Return
10100	Write 1,"-R6:",0
							' switch all 6 relays on in sequence, then after 2 secs switch all off
	midset m$,2,1,5					' set coil w/ ack
	adr=255
	For t=1 to 5
	  For x=1 to 6
	    r=x-1 v=255 GoSub 410 If rdlen=0 Then GoTo 10120
	    delay 20
	  Next x
	  delay 500
	  For x=1 to 6
	    r=x-1 v=0 GoSub 410 If rdlen=0 Then GoTo 10120
	    delay 20
	  Next x
	  delay 500
	Next t
	Write 1,"test OK ?",0
10110
	read 1,c$
	If lastlen(1)<=0 Then GoTo 10110
	If or(c$="Y",c$="y") Then Write 1,"YES\r\n",0 ftest=1 Else Write 1,"NO\r\n",0
	Return
10120	Write 1,"RD ERROR\r\n",0
	Return
	
10200	Write 1,"-X8: ",0
	adr=255
	For t=1 to 5
	  r=0 v=10 GoSub 210 If rdlen=0 Then GoTo 10120		' read back
	  For i=1 to 8
	    v=midget(t$,6+2*i,1)*256+midget(t$,7+2*i,1)
	      								' 1k,2k,3k,4k,1k,2k,3k,10k
	      								' 93, 170, 236, 292, ..., 511
	    On i GoTo 10251,10252,10253,10254,10251,10252,10253,10255
10251	    e=v-92 GoTo 10260						' values by verification
10252	    e=v-167 GoTo 10260						' values by verification
10253	    e=v-233 GoTo 10260
10254	    e=v-290 GoTo 10260
10255	    e=v-938
10260
	    If e<0 Then e=e*-1
	    If e>(v/10) Then 
	      Write 1,sprintf$("\r\nERROR Bit %u",i)+sprintf$(",%u",v)+sprintf$(",%u",e),0
	      delay 5000
	      Return
	    endif
	  Next i
	Next t
	Write 1," OK\r\n",0
	ftest=1
	Return
10300	Write 1,"-IO12: ",0				' all 12 outputs on then read back inputs and check value to be same
	adr=255
	For t=1 to 5
	  For x=1 to 12
	    r=0 v=shl(1,x-1) GoSub 110 If rdlen=0 Then GoTo 10120	' set output
	    r=0 v=2 GoSub 210 If rdlen=0 Then GoTo 10120		' read back
	    If and(rdlen=9,midget(t$,4,2)<>midget(t$,6,2)) Then 
	      Write 1, "\r\nERROR I/O #"+str$(x),0 delay 5000 Return
	    endif
	  Next x
	Next t
	Write 1," OK\r\n",0
	ftest=1
	Return
	
	
End
							